--
-- AgrocomV2_1_Beta
--
-- @author  Mike www.ls-farming.nl
-- @date  28/12/12
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

AgrocomV2_1_Beta = {}

local AgrocomV2_1_Beta_mt = Class(AgrocomV2_1_Beta, Mission00);


function AgrocomV2_1_Beta:new(baseDirectory, customMt)
    local mt = customMt;
    if mt == nil then
        mt = AgrocomV2_1_Beta_mt;
    end;
    local self = AgrocomV2_1_Beta:superClass():new(baseDirectory, mt);

--    self.playerStartX = 39;
--    self.playerStartY = 0.1;
--    self.playerStartZ = -330;
--    self.playerRotX = 0;
--    self.playerRotY = Utils.degToRad(90);

    return self;
end;

function AgrocomV2_1_Beta:delete()
    AgrocomV2_1_Beta:superClass().delete(self);
end;

function AgrocomV2_1_Beta:load()
    self:startLoadingTask();

    self.environment = Environment:new(Utils.getFilename("$data/sky/sky_day_night.i3d", self.baseDirectory), true, 8, true, true);

    self.helpIconsBase = nil;
    self.collectableHorseshoesObject = nil;
    self.fieldDefinitionBase = nil;
    self.vehicleShopBase = nil;

    self:loadMap(Utils.getFilename("Agrocom.dds", self.baseDirectory), true, self.loadMap01Finished, self);
end;

function AgrocomV2_1_Beta:loadMap01Finished(node, arguments)

    self:loadMapXMLFile(Utils.getFilename("AgrocomV2_1_Beta.xml", self.baseDirectory));

    self.missionPDA:loadMap(Utils.getFilename("pda_map.png", self.baseDirectory), 2048, 2048);

    g_inGameMenu:setMapViewsMap(Utils.getFilename("pda_map.png", self.baseDirectory));

    local iconSize = self.missionPDA.pdaMapWidth / 15;

    -- ATMs
    self.missionPDA:createMapHotspot("Bank", Utils.getFilename("$dataS2/missions/hud_pda_spot_bank.png", self.baseDirectory), 1024 - 230, 1024 + 439.5, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    
    -- Vehicle Shop
    self.missionPDA:createMapHotspot("Shop", Utils.getFilename("$dataS2/missions/hud_pda_spot_shop.png", self.baseDirectory), 1024 - 130, 1024 - 383, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

    -- farm silos
    self.missionPDA:createMapHotspot("TipPlace", Utils.getFilename("$dataS2/missions/hud_pda_spot_tipPlace.png", self.baseDirectory), 1024 + 43.5, 1024 - 128.3, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    
    -- bga
    self.missionPDA:createMapHotspot("TipPlace", Utils.getFilename("$dataS2/missions/hud_pda_spot_tipPlace.png", self.baseDirectory), 1024 + 395.1, 1024 - 693.7, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    
    -- Grass Heaps
    self.missionPDA:createMapHotspot("TipPlace", Utils.getFilename("$dataS2/missions/hud_pda_spot_tipPlaceGreen.png", self.baseDirectory), 1024 + 888.8 , 1024 + 569.6, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
   
    -- livestock
    self.missionPDA:createMapHotspot("Cows", Utils.getFilename("$dataS2/missions/hud_pda_spot_cows.png", self.baseDirectory), 1024 + 256, 1024 + 655, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    self.missionPDA:createMapHotspot("Sheep", Utils.getFilename("$dataS2/missions/hud_pda_spot_sheep.png", self.baseDirectory), 1024 - 600, 1024 + 585, iconSize, iconSize * (4 / 3), false, false, false, 0, true);
    self.missionPDA:createMapHotspot("Chickens", Utils.getFilename("$dataS2/missions/hud_pda_spot_chickens.png", self.baseDirectory), 1024 - 12, 1024 - 93, iconSize, iconSize * (4 / 3), false, false, false, 0, true);

    AgrocomV2_1_Beta:superClass().load(self);

    if not self.missionDynamicInfo.isMultiplayer then
        self:updateFoundHorseshoes();
        self:updateFoundHelpIcons();
        self:updateMeteoriteCrash();
        self:updateRainbow();
    else
        self:removeAllHorseshoes();
        self:removeAllHelpIcons();
    end;

    if g_isGamescomVersion then
        self:playerOwnsAllFields();
    end;

    self:finishLoadingTask();
end;

function AgrocomV2_1_Beta:onStartMission()
    AgrocomV2_1_Beta:superClass().onStartMission(self);
end;

function AgrocomV2_1_Beta:mouseEvent(posX, posY, isDown, isUp, button)
    AgrocomV2_1_Beta:superClass().mouseEvent(self, posX, posY, isDown, isUp, button);
end;

function AgrocomV2_1_Beta:keyEvent(unicode, sym, modifier, isDown)
    AgrocomV2_1_Beta:superClass().keyEvent(self, unicode, sym, modifier, isDown);
end;

function AgrocomV2_1_Beta:update(dt)
    AgrocomV2_1_Beta:superClass().update(self, dt);
end;

function AgrocomV2_1_Beta:draw()
    AgrocomV2_1_Beta:superClass().draw(self);
end;